
class Compressor {
  constructor() {}

  compress(string) {
    const dict = {};
    const data = (string + "").split("");
    const output = [];
    let currentChar;
    let phrase = data[0];
    let code = 256;
    
    for (let i = 1; i < data.length; i++) {
      currentChar = data[i];
      
      if (dict[phrase + currentChar] != null) phrase += currentChar;
      else {
        output.push(phrase.length > 1 ? dict[phrase] : phrase.charCodeAt(0));
        dict[phrase + currentChar] = code;
        code++;
        phrase = currentChar;
      }
    }
    output.push(phrase.length > 1 ? dict[phrase] : phrase.charCodeAt(0));
    return output.map(str => String.fromCharCode(str)).join("");
  }

  decompress(string) {
    const dict = {};
    const data = (string + "").split("");
    let currentChar = data[0];
    let code = 256;
    let phrase;
    let oldPhrase = currentChar;
    const output = [ currentChar ];
    
    for (let i = 1; i < data.length; i++) {
      const currentCode = data[i].charCodeAt(0);
      
      if (currentCode < 256) phrase = data[i];
      else phrase = dict[currentCode] ? dict[currentCode] : (oldPhrase + currentChar);
      
      output.push(phrase);
      currentChar = phrase.charAt(0);
      dict[code] = oldPhrase + currentChar;
      code++;
      oldPhrase = phrase;
    }
    return output.join("");
  }
}

export default new Compressor();
