import { world, system } from "@minecraft/server";
import compressor from "./lib/compressor";
import { Screen } from "./lib/screen";
import { formEntity } from "./lib/forms";

const screenId = "mframe:small";
const playerId = "minecraft:player";

system.run(function tick() {
  system.run(tick);
  
  for (const screenEntity of world.getDimension("overworld").getEntities({ type: screenId })) {
    const rawImage = screenEntity.getTags()[0];

    if (!rawImage) continue;
    const screen = new Screen(screenEntity);
    const pixels = JSON.parse(compressor.decompress(rawImage));

    screen.paint(pixels);
  }
});

world.events.entityHit.subscribe((event) => {
  const { hitEntity, entity } = event;
  
  if (hitEntity.typeId != screenId || entity.typeId != playerId) return;
  formEntity(entity, hitEntity);
});


system.events.beforeWatchdogTerminate.subscribe((event) => {
  event.cancel = true;
});
